package heasarc.w3browse.plot;

/**
 *           W3Browse Plotting Package                          **
 *                                                              **
 * SOURCE: Cumulative.java                                      **
 *                                                              **
 * @author Saima Zobair (RITSS)   saima@lheamail.gsfc.nasa.gov  **
 *                                                              **
 *****************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/** This class creates cumulative histogram plots.
 */
public class Cumulative extends Histogram {
  /////////////////////////////////////////////////////////////////
  ///                      constructor                          ///
  /** Constructor for Cumulative */
  public Cumulative(Column col,int nrows,int bin) {
    this.col = col;
    if (bin > 0)
      this.bins = bin;
    this.range = new double[this.bins+1];
    setHistRanges();
    setFrequency(nrows);
    getHistPoints();
  }
  /////////////////////////////////////////////////////////////////
  ///                      private methods                      ///
  /** set cumulative Frequency */
  public void setFrequency(int nrows) {
    frequency = new long[bins];
    double data[] = col.getData();

    int total=nrows;
    frequency[0] = total;
    for (int i=1;i<this.bins;i++) {
      frequency[i] = 0;
      for(int j=0;j<nrows;j++){
         if(Double.isNaN(data[j]))
           continue;

         if(i == 1) {
           if(data[j] < range[i+1])
             total--;
         } else { 
           if(data[j] >= range[i] && (data[j] < range[i+1]))
             total--;
         }
      }
      frequency[i] = total;
    }

  }
}

