# $Id: DPScriptToFile.pm,v 1.3 2004/12/15 21:02:07 lmm Exp $
#
# DPScriptToFile provides methods to create and download
# a script file of data product download commands.
#
# See ProdScriptGen and ProdMain packages for more information
#
# See the end of this file for cvs logs.
#

use strict;

use Browse::ProdMain;
use Browse::HProdScriptGen;

package Browse::DPScriptToFile;

# Inheritance.
use vars qw( @ISA );
@ISA = qw( Browse::HProdScriptGen );

#--- Overwritten and new methods 
sub pageHeader {
   my ($self,$in) = @_;
   #--- Define mime type for download and then display some instructions
   print "Content-Type:application/x-download\n" .
      "Content-Disposition:attachment;filename=browse_download_script.txt\n\n";
   print "# The following commands will download selected data products.\n"; 
   print "#\n";
   print "# Note: The network utility wget is included with most\n" .
      "# systems.  To download wget or get more information visit the\n" .
      "# GNU website http://www.gnu.org/software/wget/wget.html\n" .
      "#\n";
}

sub pageFooter {}

sub commandStart { }

sub commandEnd {
   my ($self);
   #--- Add new line to end of every command
   print "\n";
}

sub commandHeader { }

sub commandFooter {
   my ($self,$total)=@_;
   print "\n# Total size of data product files local to the " .
	"HEASARC system: " . 
   $self->optsize($total) .  "\n# File sizes of remote data products are " .
	"not available";
}



1;
# $Log: DPScriptToFile.pm,v $
# Revision 1.3  2004/12/15 21:02:07  lmm
# Changed extension of file to .txt
#
# Revision 1.2  2004/12/09 19:29:26  lmm
# Combined Content-type and Content-Disposition lines for use with modperl
#   (requested for Akbar)
#
# Revision 1.1  2004/12/06 16:14:26  lmm
# Provides methods to create and download a script file of data product
#   download commands
#
