# $Id: Decor.pm,v 1.48 2008/06/06 18:38:56 lmm Exp $
# $Log: Decor.pm,v $
# Revision 1.48  2008/06/06 18:38:56  lmm
# Now using feedback form for "page maintainer" link.
#
# Revision 1.47  2006/10/24 17:10:22  lmm
# Added link to new JavaScript file w3main.js.
# Added call to JavaScript function PageLoaded().
#
# Revision 1.46  2006/06/23 14:11:06  lmm
# Moved results summary table JavaScript code to separate file.
#
# Revision 1.45  2005/12/13 16:53:01  lmm
# Summary table row count now stays blank until table has been processed
#
# Revision 1.44  2005/08/11 15:27:41  lmm
# Changed some syntax in incrementCount() javascript so that it will
#   work in IE.
#
# Revision 1.43  2005/06/23 19:36:31  lmm
# Previous change to prevent form submission after return key press did not
#   work for all browsers.  New code is a bit better.
#
# Revision 1.42  2005/06/22 20:50:22  lmm
# Added javascript to prevent submit action if return key is pressed.
# Updated Hera link to point to new web page.
#
# Revision 1.41  2004/12/15 19:51:11  lmm
# Added JavaScript functions to update new table name/hits display as
#   results are displayed on page
#
# Revision 1.40  2004/09/14 18:38:31  lmm
# Added definition of default css style if it is not specified as a
#   parameter to the Header subroutine
# The page background color is now defined only if the HEASARC banner
#   is not displayed
# Made some cosmetic changes (removal of old unused code)
#
# Revision 1.39  2004/01/16 15:12:15  lmm
# Added alt tag to image
#
# Revision 1.38  2003/09/09 17:47:21  lmm
# Removed hardcoded tip archive file name
#
# Revision 1.37  2003/09/08 20:19:43  lmm
# Browse Home link now points to Browse link on main HEASARC page
#
# Revision 1.36  2003/08/29 17:06:46  lmm
# Display window now brought to front when loading is complete
# Footer routine split into routines to display Browse email address,
#    write HTML end tags and display HEASARC footer
# Added HEASARC banner flag so banner does not appear on every page
# Added style parameter for header
#
# Revision 1.35  2003/07/31 15:28:54  lmm
# added javascript tips.js for random tip on Display page
# Added Tip archive image and link
#
# Revision 1.34  2003/04/28 02:26:32  cwh
# Removed cookie support.
# Added icon for Hera-enabled version.
#
# Revision 1.33  2002/10/25 22:07:39  cwh
# Added quotes.
#
# Revision 1.32  2002/10/17 22:10:32  cwh
# Added new style sheet.
#
# Revision 1.31  2002/09/13 19:15:11  cwh
# Added doctype declaration.
# Commented out where we subbed '-' for space in mimssion names - was being
#   passed back and causing sorting of tables to fail.
#
# Revision 1.30  2002/09/05 18:11:34  cwh
# Removed unneeded <div>.
#
# Revision 1.29  2002/07/31 17:08:38  cwh
# Changed maintainer email link to use Feedback script if local.
# Commented out some unneeded html.
#
# Revision 1.28  2002/07/08 16:19:26  cwh
# Header now allows a cookie to be passed in and added to the header lines.
#
# Revision 1.27  2002/04/10 22:08:18  cwh
# Changed size of help gif.
#
# Revision 1.26  2002/04/02 23:41:29  cwh
# Got rid of extra <p> tags that were causing trouble with IE5 on Macs.
# Commented out extra end-of-table stuff that we're not using anymore.
#
# Revision 1.25  2002/03/15 23:42:56  cwh
# Added print media stylesheet, made other changes in HTML.
#
# Revision 1.24  2001/12/04 15:49:01  cwh
# Changed title from Browse to HEASARC Browse.
#
# Revision 1.23  2001/11/20 15:46:10  cwh
# Copied the Heasarc help icon into the $::images directory so I can get rid of
# the Heasarc-specific path to it.
#
# Revision 1.22  2001/11/07 23:34:18  cwh
# Moved everything except DBD/ into lib/Browse/, so as not to pollute the module
# namespace with our Sort, Search, CGI, etc.  This required putting Browse:: in
# front of every module call and package declaration.  Also any mod::new() had
# to be changed to mod->new().
#
# Revision 1.21  2001/10/29 20:32:54  cwh
# Fixed problem where the mission names were not being printed in the browser
#   title on the w3table.pl page.
#
# Revision 1.20  2001/09/15 13:33:50  cwh
# Cleaned up the header output.
# Added new HEASARC help icon.
#
# Revision 1.19  2001/07/17 19:09:33  cwh
# Changed the menubar and footer inclusion to use ::includefile($file).
#
# Revision 1.18  2001/07/10 20:57:45  cwh
# Moved Menubar into body, fixed html code typo, removed shebang line.
#
# Revision 1.17  2001/07/01 01:32:41  cwh
# Got rid of superfluous local variables that were copies of globals.
# Moved all HEASARC-specific filenames, urls, emails, etc to w3config.pl.
#
# Revision 1.16  2001/04/09 15:28:16  cwh
# Changed Month dd yyyy to dd Month yyyy.
#
# Revision 1.15  2001/04/03 16:34:29  cwh
# - changed page title to "Main Interface" if title = Browse
# - changed help doc to w3browse-help.pl from w3browse-help2.pl
# - changed date format from 11/03/01 to November 03 2001.
#
# Revision 1.14  2001/03/12 16:36:57  cwh
# Changed heading bar - replaced image with link, also got rid of non-breaking
# spaces in favor of table columns.  Heading font size is +3 if "Browse", +2
# otherwise.
#
# Revision 1.13  2001/02/15 21:18:25  cwh
# Took out survey info.
#
# Revision 1.12  2001/01/02 23:28:14  cwh
# Added stylesheet.
#
# Added target=helpwin for all help links.
#
# Removed qmark.gif.
#
# Replaced datamenu.html with browsemenu.html.
#
# Revision 1.11  2000/06/23 17:38:26  saima
# Removed HEASARC icon.
#
# Revision 1.10  2000/03/09 22:08:33  saima
# Added contents of /docs/corpfooter.html to Decor::Footer().
#
# Revision 1.9  2000/03/08 20:08:32  saima
# W3Browse to Browse name change. Also, added the new menubar to the
#   Header().
#
# Revision 1.8  2000/02/28 20:53:27  saima
# Added new menubar on the Header() and removed old menubar.
#
# Revision 1.7  2000/02/08 15:35:01  saima
# Added a link to the Browse Survey.
#
# Revision 1.6  2000/01/11 19:27:19  saima
# Fixed a y2k related bug where year was coming up as 100 instead of '00'.
#
# Revision 1.5  1999/12/20 17:45:05  saima
# Fixed a minor bug where the title on a Mac browser had '&nbsp' in it.
#
# Revision 1.4  1999/09/13 18:22:47  saima
# Added link to the w3browse help page from the header.
#
# Revision 1.3  1999/09/03 20:34:06  saima
# Link to MissionHelp is now relative.
#
# Revision 1.2  1999/08/26 17:23:16  saima
# Modified &Footer() with $end_tags info.
#
# Revision 1.1  1998/12/22 20:35:16  saima
# Previosuly known as Decor.pl. Added new W3Browse header and made other
#   changes to urls.
#
# Revision 1.30  1998/08/04 19:04:12  saima
# W3Browse link no longer points to the framed page.
#
# Revision 1.29  1998/07/15 17:50:15  saima
# Modified the header so that the W3Browse icon goes to a page which
#   contains the HEASARC frame.
#
# Revision 1.28  1998/06/26 18:41:08  saima
# Code now executes 'watermarkMenuBar' when adding the menubar.
#
# Revision 1.27  1998/06/12 19:51:14  saima
# Mission link now calls a routine which displays overview
#   information on each valid table's help files.
#
# Revision 1.26  1998/06/09 16:05:34  saima
# Minor tweaks to Header() so that links work correctly with frames.
#
# Revision 1.25  1998/06/08 18:54:06  saima
# Made necessary changes to make the MenuBar a client-side image map so
#   that it works correctly with frames.
#
# Revision 1.24  1998/05/12 18:02:16  saima
# Modified Header() to use the variable $::version to get version number.
#
# Revision 1.23  1998/03/30 20:13:12  saima
# Modified incorrect link to new databases.
#
# Revision 1.22  1998/03/26 19:30:14  saima
# Corrected link to version history file.
#
# Revision 1.21  1998/03/20 19:36:45  saima
# Added links to Overview and What's New in the top header.
#
# Revision 1.20  1998/03/04 22:26:20  saima
# Added $::writeHeader flag to better control if the content type line
#    has been printed. Once the content type line is printed
#    $::writeHeader is set to 0.This variable controls the &::Error
#    routine from returning error messages to the user unnecessarily.
#
# Revision 1.19  1997/11/25 23:09:47  saima
# Added -T switch to perl version.
#
# Revision 1.18  1997/08/26 19:59:19  saima
# The version number in Header() comes from $::version now.
#
# Revision 1.17  1997/08/19 22:13:49  saima
# Moved HEASARC menubar to the bottom of the page, created a new W3Browse
#   bar for the top of each W3Browse page. Added HEASARC logo, changed
#   question mark gif.
#
# Revision 1.16  1997/04/17 22:07:53  sabol
# Added MissionLinks() function to decorate a list of mission names with their
#   corresponding URLs.
#
# Revision 1.15  1997/03/26 19:39:52  sabol
# Added New() routine for specifying the HTML of the "New!" icon.
#
# Revision 1.14  1996/12/19 23:04:50  sabol
# Made all URLs relative instead of absolute. Now uses $::w3bhelp config
#   variable for designating the URL for W3Browse Help.
#
# Revision 1.13  1996/10/16 16:20:28  sabol
# Made compliant with Perl 5's "use strict" compiler directive.
#
# Revision 1.12  1996/08/26 22:42:43  sabol
# Minor code cleaning.
#
# Revision 1.11  1996/08/26 18:35:05  sabol
# Cleaned up code for consistent style across all files.
#
# Revision 1.10  1996/06/27 17:17:44  sabol
# Minor code clean-ups and cosmetic changes.
#
# Revision 1.9  1996/06/26 21:55:48  sabol
# Fixed hyperlinks so as to stay on the same server as you are on. Also, made
#   minor and probably unnoticeable cosmetic changes.
#
# Revision 1.8  1996/06/25 21:00:48  sabol
# Updated all source code to be Perl 5-compatiable.
#
# Revision 1.7  1996/05/07 15:21:21  sabol
# W3Browse now displays modified Julian dates in ISO-standard year-month-day
#   format. Created version history file and added a link to it from each
#   W3Browse page. Centralized all source code that interacts with HDBmc.
#   Made the source code more modular with more reusability. Better security
#   on all HDBmc calls. Reduced the number of HDBmc calls in order to do an
#   object name/coordinate search, resulting in better efficiency and faster
#   response. Users can now select multiple missions on the main page and
#   still be able to do a parameter query. Now uses table_document_url ZZGEN
#   parameter for constructing all help links in the parameter query forms.
#   The Fields and GIF Image Display Limit pop-up menus on the parameter
#   query form now retain state between query builds.
#
# Revision 1.6  1996/03/13  19:30:39  sabol
# Bug fix for search radius symbols and now preserve directory structure
#  in tar files.
#
# Revision 1.5  1996/03/01  16:56:17  kressel
# More work on submit buttons. Including MailMessage routine.
#   Some small changes to aesthetics.
#
# Revision 1.4  1996/02/16  13:53:11  kressel
# Workaround for Mosaic - removed Location: http:// ....w3nprep in
# w3nquery.
#    Changed tabs to spaces in w3browse display of observatories.
#    Only displaying ResultsFooter when necessary.
#    Fix for HDBfilter calls for tables with no coordinate parameters.
#    Fix for virtual parameters with leading @.
#
# Revision 1.3  1996/02/08  18:50:38  kressel
# Fixed bug for $host in w3config and HDProds.
#
# Revision 1.2  1995/12/27  17:27:40  kressel
# Redo of Initial CVS, to exclude binaries; and
#   GetParams.pl replaces w3defpars.pl
#   Presence of decimal point in 'ra' field implies Decimal degrees.
#   Have high level of confidence with handling of Coordinates now.
#   End of major version for December 95.
#
# Revision 1.1.1.1  1995/12/19 19:38:05  kressel
# W3Browse Initial CVS
#
# Revision 1.1  1995/10/17  17:44:02  kressel
# Initial revision
#
#=========================================================================#
# High Energy Astrophysics Science Archive Research Center (HEASARC),
# NASA's Goddard Space Flight Center, Greenbelt, MD 20771, USA.
#
# You are free to use this code as you wish, but unless you change
# it significantly, please leave the above name & address intact.
#=========================================================================#
# Module Name:    Decor.pl
# Module Authors: Alan Richmond (HSTX), John Kressel (HSTX),
#                       Edward J. Sabol (HSTX), Saima Zobair (RITSS)
# Date:           Sept, 95
# Project:        Browse : HEASARC
#=========================================================================#
# Module Description:
# This module contains subroutines for Header & Footer decorations.
#=========================================================================#

use strict;

package	Browse::Decor;

$| = 1; # Force print buffer flush

#--------------------------------------------------------------------------
sub Header { # Sets up a HTML page for writing to. Inserts header, title

    #my($title,$closetable,$cols,$cookies) = @_;
    #my($title,$closetable,$cols) = @_;
    my($title,$closetable,$cols,$banner, $style) = @_;

    ($title = &ResultsTitle) if ($title =~ /^results/);
    my($mtitle)  = $title;
    $mtitle      =~ s/\<[^>]*?>//g;  #remove html
    $mtitle      =~ s/\&nbsp\;/ /g; 
    $mtitle = "Main Interface" if $mtitle =~ /HEASARC Browse/;
    my $fclass = "larger";
    $fclass = "largest" if $title =~ /HEASARC Browse/;
    my $menu = &Menubar();
    $style="standard" unless $style;

#    foreach my $cookie (keys %$cookies) {
#       print "Set-Cookie: $cookie=$$cookies{$cookie}; path=/\n";
#    }
    print  "Content-type: text/html\n\n";

    # set to 0 when content-type header is printed
    $::writeHeader = 0;  

    print <<EOT;
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
    <html><head><title>HEASARC Browse: $mtitle</title>
    <link rel="stylesheet" href="$::w3bdocs/w3browsetable.css" title="colortable style" type="text/css" media="screen">
    <link rel="alternate stylesheet" href="$::w3bdocs/w3browse.css" title="scrolltable style" type="text/css" media="screen">
    <link rel="stylesheet" href="$::w3bdocs/w3browseprint.css" title="print style" type="text/css" media="print"> 
    <script type='text/javascript' src="$::w3bdocs/tips/tips.js"></script> 
    <script type='text/javascript' src="$::w3bdocs/w3main.js"></script>
    <script type='text/javascript' src="$::w3bdocs/w3summaryhtml.js"></script> 
    <script language='JavaScript' type='text/javascript'>


    //--- Prevent submit when return key is pressed
    function noenter(evt) {
        //return !(window.event && window.event.keyCode == 13); 
       evt = (evt) ? evt : event;
       var charCode = (evt.charCode) ? evt.charCode :
	   ((evt.which) ? evt.which : evt.keyCode); 
       if (charCode == 13 || charCode == 3) {
          return  false;
       } else {
          return  true;
       }
       
    }
    </script>
EOT

    #<body bgcolor="#ffffff" text="#090909"
          #link="#0505ff" vlink="#ff0000" alink="#c0f0c0" onLoad="self.focus()"> 

    if ($banner) {
       print <<EOT;
       $menu
EOT
    } else {
       print <<EOT;
       </head>
       <body bgcolor="#ffffff" text="#090909" 
       link="#0505ff" vlink="#ff0000" alink="#c0f0c0" onLoad="pageLoaded();changeLink()"> 
EOT
    }
    print <<EOT;
    <table width="100%" border="1">
    <tr><td>
      <table width="100%" cellspacing="0">
        <tr class='$style'>
              <td width="10%" align="left">&nbsp;&nbsp;&nbsp;&nbsp;<a href="$::mainbrowse"><b>Archive</b></a></td>
              <td align="center" class="$fclass">$title</td>
              <td align="right">
<a href="$::w3bdocs/w3btipsarchive.html" ><img src="$::images/tiparchive.jpg" border="0" alt="Tips Archive"></a>

<a href="http://heasarc.gsfc.nasa.gov/hera"><img border="0" alt="You are using the Hera-enabled Browse" height="32" width="45" src="$::images/test/hera_white_on_gold-red_oval.gif"></a> <a target="helpwin" href="$::w3bhelp"><img border="0" alt="Help" src="$::images/help.gif" height="30" width="30"></a></td>
        </tr>
      </table>
    </td></tr>
    </table>
EOT

} # eosub--Header
#--------------------------------------------------------------------------
sub PageTitle { #returns a title to display using <H2>.

    my($title) = join(' ',@_);

    print "<h2>$title</h2>";

} #eosub--PageTitle
#--------------------------------------------------------------------------
sub ResultsTitle {

     my($today) = &today;
     my($title) = "Search Results of $today";

     return ($title);

} #eosub--ResultsTitle
#--------------------------------------------------------------------------
sub Menubar {

     return Browse::Utils::includefile($::menubar) if -s $::menubar;
}
#--------------------------------------------------------------------------
sub Footer { # includes the LHEA footer, page author, and closes the HTML
    EmailFooter();
    print Browse::Utils::includefile($::footer) if -s $::footer;
    EndTags();


} #eosub--Footer

sub EmailFooter { # display Browse dev Team email address

print <<EOT;
<p>
<span style='font-size:90%'>Page maintainer: 
<a href="/cgi-bin/Feedback?selected=w3browse"> Browse Feedback</a></span>
EOT

}
#--------------------------------------------------------------------------

sub EndTags { # closes the HTML
    my($endtags) = 0;  # this was set to 1, not sure why
    if(scalar(@_)) {
       $endtags = @_;
    }  
    if (!$endtags) {
      print <<EOT;
</body>
</html>
EOT
    }
}

#--------------------------------------------------------------------------
sub today {
    #### Returns a string containing today's date in MM/DD/YY format.
    # Changed to return Month dd yyyy

    my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    my $Month = ("January","February","March","April","May","June","July","August","September","October","November","December")[$mon];
    #$mon++;
    #return "$mon/$mday/".substr($year,length($year)-2, 2);
    return "$mday $Month ". ($year+1900);

} #eosub--today
#--------------------------------------------------------------------------
sub MissionLinks {
    # Function  input: a hash with the following keys:
    #   'missions'   => ref to array of missions
    #   'separator'  => string to be used as the separator (default: ", ")
    # Function output: HTML string that implements a list hyperlinked
    #                   missions names

    my(%args) = @_;
    $args{'separator'} = ', ' unless (defined($args{'separator'}));

    # Build the HTML.
    my($html) = '';
    my(@links) = ();
    my($mission,$link);
    foreach $mission (@{ $args{'missions'} }) {
	$link = lc($mission);
	$link =~ tr/ /\_/;
#	$mission =~ tr/ /\-/;
	push(@links,"<a target=helpwin href=\"w3table.pl?MissionHelp=\L$link\E\">\U$mission\E</a>");
    }

    $html = join($args{'separator'},@links) if (scalar(@links));

    return($html);

} #eosub--MissionLinks
#--------------------------------------------------------------------------
sub Acknowledge {       # Instructs users to acknowledge HEASARC if
                        # a publication results from surfing HEASARC,
                        # provides the acknowledgement text and an address
                        # for sending preprints our way.

    print <<EOT;

<hr>
The <a target=helpwin href="$::heasarc/">HEASARC Online Service</a> is provided by the
Laboratory for High Energy Astrophysics at NASA/Goddard Space Flight Center.
If using this service made a significant contribution to a research project,
please make the following acknowledgment in any resulting publication:
<p><i>
"This research has made use of data obtained through the High Energy
Astrophysics Science Archive Research Center Online Service, provided
by the NASA/Goddard Space Flight Center."
</i><p>
Please send a preprint or reprint of the paper to:<p>
	The HEASARC, Code 660.2, NASA/Goddard Space Flight Center,
	Greenbelt, Maryland, 20771, USA.
EOT

} #eosub--Acknowledge
#--------------------------------------------------------------------------
1;
#########
#  EOF  #
#########
