# $Id: SkyView.pm,v 1.8 2007/06/05 13:12:17 lmm Exp $


use strict;
package Browse::SkyView;

use Browse::CGI;

sub skyviewSystem {
   return "skyview.gsfc.nasa.gov";
}

sub prepareImage {

   #-- image center coordinates, Skyview survey, coordinate system,
   #-- equinox of coordinates, image size
   my ($coord1,$coord2,$survey,$coordSys,$equinox,$imagesizeX,$imagesizeY) =@_;

   
   my($system) = skyviewSystem();
   my($coords) = Browse::CGI::Encode($coord1 . ", " . $coord2);

   my($url) = "http://$system/cgi-bin/pskcall?VCOORD=$coords" .
	"&SURVEY=$survey&SCOORD=$coordSys&EQUINX=$equinox" .
	#"&COLTAB=Stern+Special" .
	"&LUT=colortables%2Fstern-special.bin" .
	"&PIXELX=$imagesizeX&PIXELY=$imagesizeY&RETURN=GIF";

   return $url;
}
sub prepareLink {

   my ($coord1, $coord2,  $survey,$coordSys,$equinox) =@_;

   my($system) = skyviewSystem();
   my($coords) = Browse::CGI::Encode($coord1 . ", " . $coord2);

   my($url) = "http://$system/cgi-bin/nnskcall.pl?VCOORD=$coords" .
	"&SURVEY=$survey&SCOORD=$coordSys&EQUINX=$equinox" .
	"&LUT=colortables%2Fstern-special.bin";

   return $url;
}



1;
# $Log: SkyView.pm,v $
# Revision 1.8  2007/06/05 13:12:17  lmm
# Updated skyview query URL and image link for new skyview software release.
#
# Revision 1.7  2004/12/15 20:56:15  lmm
# Added subroutine skyviewSystem() to make it easy to change which
#   skyview machine to query
#
# Revision 1.6  2004/07/01 14:27:58  lmm
# Added parameters to prepareImage() to specify image pixel size
#
# Revision 1.5  2003/09/03 21:34:33  lmm
# Methods for accessing SkyView images
#
