# $Id: StreamDisplay.pm,v 1.3 2002/05/14 18:05:30 cwh Exp $
# $Log: StreamDisplay.pm,v $
# Revision 1.3  2002/05/14 18:05:30  cwh
# Needed to add a 'use'.
#
# Revision 1.2  2001/11/07 23:34:20  cwh
# Moved everything except DBD/ into lib/Browse/, so as not to pollute the module
# namespace with our Sort, Search, CGI, etc.  This required putting Browse:: in
# front of every module call and package declaration.  Also any mod::new() had
# to be changed to mod->new().
#
# Revision 1.1  2001/10/25 20:12:14  cwh
# Separated these from the Display.pm module.
#

# This class displays the results in a text stream where
# different rows may have different lengths for a given column.

use strict;

package Browse::StreamDisplay;

use vars qw( @ISA );
@ISA = qw( Browse::BatchDisplay );
use Browse::BatchDisplay;


# Unlike the BatchDisplay we can process
# each line as we receive it.

sub processData {

    my ($self, $data) = @_;
    
    if ($$self{"rowcount"} == 0) {
        $$self{"transform"} = $self->setTransform($data);
        $$self{"intable"} = 1;
        my $names = $$data{"names"};
	my $header =  "|".join("|", @$names)."|";
	print $header,"\n";
        my $types = $$data{"types"};
        $header =  "|".join("|", @$types)."|";
	print $header,"\n";
    }
    
    #my $trans = $$self{"transform"};
    my $line = $$data{"data"};
    #Browse::TableFormat::transformLine($line, $trans);
    

    print "|",join("|", @$line), "|\n";
    $$self{"rowcount"} += 1;
}

# Just indicate close up.
sub closeTable {

    my ($self) = @_;
    
    
    if ($$self{"intable"}) {
        print "BatchEnd\n";
	$$self{"intable"} = 0;
        $$self{"rowcount"} = 0;
    }
    
}

## Successful load
1;
