#!/usr/bin/perl -T
#
# This script creates a web page to allow users to create an manage notification
# of updates for sources in current mission BROWSE tables
# 
#
#
use File::Copy;
use strict;
use lib '../lib/';
use Browse::Decor;
use Browse::Config;
use Browse::CGI;
use Astro;
use Net::DNS;
use Net::SMTP;
use Mail::Mailer;
use Crypt::Blowfish;
use HTML::Entities ();
use LWP::UserAgent;


#--- list of acceptable characters for input
#--- mainly focused on source names and coordinate formats
my $ok_chars = '\047\260a-zA-Z0-9 ,\-\:\.\@\[\]\*\+\%_';

$ENV{PATH} = "/bin:/usr/lib";
#$ENV{PATH} = "/bin:/usr/lib:/cgi-bin/w3bdev/W3Browse/notification:/www/htdocs/cgi-bin/w3bdev/W3Browse/notification";

my $server=$ENV{SERVER_NAME};  

my $form;
my $key;
my $value;
my %inputs ;
my $userdir='/tmp.shared/websec/bnotification/users';
my $archivedir;
my $workdir;
my $urlist;
#my $newsrc_sx;
my $dupmsg;
my $addmsg;
my $reactivate_message;
my $email;
my $keyw;
my $infolist;
my $ckey = pack("H16", "0123456789ABCDEF");  # min. 8 bytes
my $emailpword = 0;
my $needpassword = 0;
my $reactivate = "";
my $debug = 0;

my %missionNames = (
    swiftmastr => "Swift",
    chanmaster   => "Chandra",
    integralao   => "Integral",
    xmmmaster   => "XMM",
    suzamaster   => "Suzaku",
    xtemaster   => "RXTE",
    spitzmastr   => "Spitzer"
);

#---  Entry should be from login page
if ($ENV{'HTTP_REFERER'} !~ /W3Browse\/monitor_src\.pl/ && 
    $ENV{'SCRIPT_NAME'} != /W3Browse\/monitor_src\.pl/) {
   print "Location: /cgi-bin/W3Browse/notification/monitor_src.pl\n\n";
}

$|=1;      # Flush immediately.

#--- iPrint page header with CSS
print  "Content-type: text/html\n\n";

print <<EOT;    
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>HEASARC Browse Notification Service</title>

<link rel="stylesheet" href="/W3Browse/w3browsetable.css" title="colortable style" type="text/css" media="screen">

<link rel="alternate stylesheet" href="/W3Browse/w3browse.css" title="scrolltable style" type="text/css" media="screen">

<link rel="stylesheet" href="/W3Browse/w3browseprint.css" title="print style" type="text/css" media="print"> 
<script type='text/javascript' src="/W3Browse/w3main.js"></script>
<script language='JavaScript' type='text/javascript'>

//--- Prevent submit when return key is pressed
function disableEnterKey(e) {
     var key;

     if(window.event)
          key = window.event.keyCode;     //IE
     else
          key = e.which;     //firefox
    //alert(key);

     if(key == 13 || key == 3)
          return false;
     else
          return true;
}
//--- Click all missions
function selectAllMissions(abutton,pattern) {
   var inputs= document.getElementsByTagName("INPUT");
   if (inputs.length >0) {
      var selectall;
     //alert(abutton.value);
      if (abutton.value.match(/^Select/)) {
         selectall=1;
      } else {
         selectall=0;
      }
      var exp='.*' +pattern;
      var chkbx;
      //alert (exp);
      var re=new RegExp(exp );
      for (var i=0;i<inputs.length;i++) {
            //alert(inputs[i].id + "<-->" + inputs[i].value);
         if (inputs[i].id.match(re)) {
            //alert(inputs[i].id + " " + inputs[i].value);
            chkbx=document.getElementById(inputs[i].id)
            if (selectall) {
              chkbx.checked=true;
            } else {
              chkbx.checked=false;
            } 
            
         }
      }
      if (selectall) {
         abutton.value = "Deselect All Missions";
      } else {
         abutton.value = "Select All Missions";
      } 
   }
}
function tickTableByName(ischecked,dval) {
    var flds=document.getElementsByTagName('INPUT');
    //alert(flds.length);
    for (var i=0; i< flds.length; i++){
      if ( flds[i].name.indexOf(dval) > -1)  { 
        flds[i].checked=ischecked;
      }
    }

    return;
}
function tickTable(flds,ischecked,table) {
    alert(flds.length);
    for (var i=0; i< flds.length; i++){
      if ( (table == '') || (flds[i].value.indexOf(table) > -1) ) { 
        flds[i].checked=ischecked;
      }
    }

    return;
}

</script>
<style>
body {
   width:790px;
   margin: 0 auto;
   background-color:#FFF;
}   
.errorbox {
  background-color:#DDEEEE;
  width:95%;
  padding:5px;
  font-size:75%;
  border: solid 1px #000;
}
a:link {
   color:#00F;
}
a:visited {
   color:#F00;
}

.footer {
   font-size: 10px;
   background-color:#AAA;
}
</style>

</head>
<body  text="#090909" link="#0505ff" vlink="#ff0000" alink="#c0f0c0" "> 
<table width="100%" border="1">
 <tr><td>
  <table width="100%" cellspacing="0">
    <tr class='displayhits'>
       <td width="10%" align="left">&nbsp;&nbsp;&nbsp;&nbsp;<a href="/docs/archive.html"><b>Archive</b></a></td>
       <td align="center" class="larger">HEASARC Browse Notification Service</td>

       <td align="right">
<a href="/W3Browse/w3btipsarchive.html" ><img src="/Images/w3b/tiparchive.jpg" border="0" alt="Tips Archive"></a>

<a href="http://heasarc.gsfc.nasa.gov/hera"><img border="0" alt="You are using the Hera-enabled Browse" height="32" width="45" src="/Images/w3b/test/hera_white_on_gold-red_oval.gif"></a> <a target="helpwin" href="/W3Browse/bnotification-help.html"><img border="0" alt="Help" src="/Images/w3b/help.gif" height="30" width="30"></a></td>
    </tr>
  </table>
 </td></tr>
</table>
EOT
	
#
#--- Process form input --------------------------------------------------
#
if ( $ENV{'REQUEST_METHOD'} eq "GET" &&
      $ENV{'QUERY_STRING'} ne '') {
     $form = $ENV{'QUERY_STRING'}; 
     #print $form;
} elsif ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
    read(STDIN,$form, $ENV{'CONTENT_LENGTH'}); 
} 


#-- read input and store in hash  -----------------------------------------
my $testval;
foreach my $pair (split('&', $form)) {
  if ($pair =~ /(.*)=(.*)/) {  # found key=value;
     ($key,$value) = ($1,$2);     # get key, value.
     #print "start $key--> $value <br>" if $debug;
     $value =~ s/\+/ /g;  # substitute spaces for + signs.
     $value =~ s/%(..)/pack('c',hex($1))/eg;
     $value =~ s/^\s*//;
     $value =~ s/\s*$//;
     $value =~ s/'/\%27/;   #apostrophe
     #print "semifinal $key--> $value <br>" if $debug;
     #--- remove any bad/insecure input
     $testval=$value;
     #--- username and password have their own special check
     if ($key ne "uname" && $key ne "password") {
	$testval =~ s/[^$ok_chars]//go;
     }
     $value=$testval;
     #print "-----final $key--> $value <br>" if $debug;

     #print "referer" .$ENV{'HTTP_REFERER'} . "<br>" if $debug;
     
     if ($key =~ /needpassword/i) {
        $needpassword=1;   
         #print "setting need password flag <br>" if $debug;
     } elsif ($key =~ /emailpword/i) {
        #--- user has forgotten password
        $emailpword=1;   
         #print "setting email password flag <br>" if $debug;

     } elsif ($key =~ /done_file/i) {
        #--- user has deleted a source from the watch list
        $key =~ /done_file_(.*)/;
        my $newdeletefile=$1;
        if ($inputs{deletefile} !~ /\w/) {
           $inputs{deletefile} = $newdeletefile;
        } else {
           $inputs{deletefile} .= ":::" .$newdeletefile;
        }
        #print "will delete $newdeletefile<br>" if $debug;
        $inputs{done} = "Submit";   #-- change to trigger new source list
     } elsif ($key =~ /done_del/i) {
        #--- user has deleted a source from the watch list
        $key =~ /done_del_(.*)/;
        my $newdeletion=$1;
        if ($inputs{deletesrc} !~ /\w/) {
           $inputs{deletesrc} = $newdeletion;
        } else {
           $inputs{deletesrc} .= ":::".$newdeletion;
        }
        #print "set to delete " .$inputs{deletesrc} ." <br>" if $debug;
        $inputs{done} = "Submit";   #-- change to trigger new source list

     } elsif ($key =~ /done_notify/i) {
        #--- user has submitted changes and wants an email
        $inputs{notifyviaemail} = 1;
        $inputs{done} = "Submit";   #-- change to trigger new source list

     } elsif ($key =~ /password/i) {
        if ($value !~ /\w+/)  {
            Browse::Utils::Error("<div class='errorbox'> The password " .
		"entered is not valid. It is " .
	  	"either blank or contains an illegal character. " .
		#"(blank space, comma, \\, /, \&, \:, " .
		#"\<, \>, \'). <p> " .
		"Please click  the browser Back button and try again</div>");
        }
        if ($value =~ /[^\w\_\.\-\@]/)  {
            Browse::Utils::Error("<div class='errorbox'>The password" .
		" entered contains illegal characters " .
		#"(blank space, comma, \\, /, \&, \:, " .
		#"\<, \>, \') " .
		"and is not valid.<p> Please click  the browser " .
		"Back button and try again.</div>");
        }
        #--- a password has been entered
        my $initkey=$value;
        #print "p=$initkey " . length($initkey) . "<br>" if $debug;
        my $plural = "s";
        if (length($initkey) == 1) {
          $plural = "";
        }
        if (length($initkey) < 8) {
            Browse::Utils::Error("<div class='errorbox'>The password " .
		"entered has less than " .
	  	"eight characters and is not valid. It only has ". 
		length($initkey)." character" . "$plural.<p> " .
		"Please click  the browser Back button and try again.</div>");
        } elsif (length($initkey) > 8) {
             $initkey=substr($initkey, 0, 8); 
        }
        my $cipher = new Crypt::Blowfish $ckey;
        $keyw = $cipher->encrypt("$initkey");  
        my $dtext = $cipher->decrypt($keyw);

     } else {
        # create associative array of form parameters.
        $inputs{$key} = $value;   
     }
  }
}

#--- error checking - check for user name
if ($inputs{entry} eq "Submit" && !$inputs{uname}) {
   Browse::Utils::Error("<div class='errorbox'>A user name was not entered." .
	"<p> Please click the browser Back button and try again</div>");
}
##--- Redisplay Login page if user wants to logout
#if ($inputs{done_logout}){
   #my $login = displayLogin();
   #print "$login";
   #close_page();
   #undef %inputs;
   #exit;
#}

#--- Send password  to user's current email address 
if ($needpassword) {
   Browse::Utils::Error( "<div class='errorbox'>Enter your user name " .
		 "and your password will be sent to the email currently on " .
		 "file.   After submitting this form you will be redirected " .
		 "back to the login page.<p><p>\n" .
                 "<form method='post' action='monitor_src.pl'>\n" .
                 "<LABEL for='uname'>Name: </LABEL>\n".
                 "<INPUT type='hidden' name='done_logout' value='Logout'>\n" .
                 "<INPUT type='text' id='uname' size='30' name='uname'><p>\n" .
		 "<INPUT TYPE='Submit' name='emailpword' " .
		 "VALUE='Send Password'></form></div><p>\n");
}
   
#--- Send password  to user's current email address and display Login page
if ($emailpword) {
   if (!$inputs{uname}) {
      Browse::Utils::Error("Please enter a user name");
      undef %inputs;
      exit();
   }
   #print "mailing password " . $inputs{uname} . " $ckey<br>" if $debug;
   emailPword($inputs{uname}, $ckey);
   my $login = displayLogin();
   print $login;
   close_page();
   undef %inputs;
   exit;  #--- don't display any other data
}

#--- Redisplay Login page if user wants to logout
if ($inputs{done_logout}){
   my $login = displayLogin();
   print "$login";
   close_page();
   undef %inputs;
   exit;
}

#---Remove any source selected for deletion 
if ($inputs{deletesrc} ne ''){
   my $deletelist = $inputs{deletesrc};
   my @delete = split(/:::/, $deletelist);
   #print "deleting ".scalar(@delete) ." items<br>" if $debug;
   foreach my $xx (@delete) {
     #print "deleting ". $xx ."<br>" if $debug;
     # my $tobedeleted = $inputs{deletesrc} . "ckbutton";
      my $tobedeleted = Browse::CGI::Decode($xx) . "ckbutton";
     #print "trying to delete  ". $tobedeleted ."<br>" if $debug;
      #$tobedeleted =~ s/\+/_/g;  #--- replace metacharacter
      $tobedeleted =~ s/\+/\\+/g;  #--- replace metacharacter
      $tobedeleted =~ s/\s+/_/g;  #--- replace metacharacter
     #print "+trying to delete  ". $tobedeleted ."<br>" if $debug;
      foreach my $key (keys %inputs) {
        (my $qkey = $key) =~ s/\+/_/g;  #replace metacharacter

        if (Browse::CGI::Decode($qkey) =~ /^$tobedeleted/) { 
           #print "****deleting $key : " . $inputs{$key} . "<br>" if $debug;
           delete $inputs{$key};
        }
      }
      #print "-------------------------------------<br>" if $debug;
   }
}

#if ($debug) {
   #print "--- inputs status ---<br>";
   #foreach my $key (keys %inputs) {
      #print " $key => $inputs{$key}<br>";
   #}
#}
    
my %srctable=() ;
my %resolverlinks=() ;

#--- Create user directory if it does not exist -----------------------
if ($inputs{uname} ne '') {
   
   $workdir ="$userdir/".$inputs{uname};
   $infolist ="$userdir/".$inputs{uname}."/info.list";
   $urlist=$userdir.'/'.$inputs{uname}."/url.list";
   $archivedir=$workdir.'/archive';
}

#---Remove any files selected for deletion 
if ($inputs{deletefile} ne '') {
   my @deletefiles = split(/:::/,$inputs{deletefile});
   foreach my $delfile (@deletefiles) {
     # my $tobedeleted_d = Browse::CGI::Decode($inputs{deletefile});
      my $tobedeleted_d = Browse::CGI::Decode($delfile);
      $tobedeleted_d =~ s/ /_/g;  #--- replace metacharacter
      (my $tobedeleted_org = $tobedeleted_d) =~ s/d\.html$/org\.html/;  
      (my $tobedeleted_new = $tobedeleted_d) =~ s/d\.html$/new\.html/;  
      (my $tobedeleted_chgs = $tobedeleted_d) =~ s/d\.html$/chgs\.html/;  
      #print " delete file " .  $tobedeleted_d . "  ..  " .
	#"$tobedeleted_org  .. $tobedeleted_new .. $tobedeleted_chgs" .
	#"<br>\n" if $debug;
      my $deleted;
      if (-e "$archivedir/$tobedeleted_d") {
         #print "unlinking $workdir/archive/$tobedeleted_d<br>" if $debug;
         $deleted=unlink ("$archivedir/$tobedeleted_d");
         #print "file delete error $deleted ." if $debug;
      }
      if (-e "$archivedir/$tobedeleted_org") {
         $deleted=unlink("$archivedir/$tobedeleted_org");
         #print "file delete error $deleted ." if $debug;
      }
      if (-e "$archivedir/$tobedeleted_new") {
         $deleted=unlink("$archivedir/$tobedeleted_new");
         #print "file delete error $deleted ." if $debug;
      }
      if (-e "$archivedir/$tobedeleted_chgs") {
         $deleted=unlink("$archivedir/$tobedeleted_chgs");
         #print "file delete error $deleted ." if $debug;
      }
   }
}


#--- Look for saved URL list to see if this account was
#--- previously active.   Check to see if user submitted reactivation.
if (! -e $urlist) {
   #print " no $urlist!<br>" if $debug;
} else {
   #print "!!yes $urlist!<br>" if $debug;
} 
if (! -e "$urlist.relogin") {
   #print " no $urlist.relogin <br>" if $debug;
} else {
   #print "!!yes $urlist.relogin <br>" if $debug;
} 
if (! -e "$urlist.save") {
   #print " no $urlist.save <br>" if $debug;
} else {
   #print "!!yes $urlist.save <br>" if $debug;
}
#print "reactivate=$reactivate<br>" if $debug;
 
#-------
if ($urlist && -e "$urlist.relogin"  && $inputs{done} =~ /\bSubmit\b/i 
	    && $reactivate eq "") {
   #--- User submitted form after re-login after cancellation
   #--- URL list exists so rm file "flag"
   #print "---removing $urlist.relogin<br>" if $debug;
   system ("rm " . "$urlist.relogin");  #removed file "flag"
   #$reactivate_message="Your account has been reactivated <br>\n";
} elsif ($urlist && -e "$urlist.save"  && ! -e $urlist && $reactivate eq "") {
   #print "Re-login after cancelation<br>" if $debug;
   $reactivate = $urlist;
   $urlist = "$urlist.save";
   $reactivate_message="Your account will be reactivated after Submit<br>\n";
} elsif ($urlist && -e "$urlist.relogin"  && ! -e $urlist && $reactivate eq "") {
   #--- User did not submit form after re-login after cancellation
   #--- 
   $reactivate = $urlist;
   #print "mv " . "$urlist.relogin $urlist.save" . "<br>" if $debug;  
   system ("mv " . "$urlist.relogin $urlist.save");  
   $urlist = "$urlist.save";
   $reactivate_message="Please click Submit to reactivate your account<br>\n";
}

if ($inputs{done_cancel} && $urlist){
   #print "cancelling service $urlist<br>" if $debug;
   if ($urlist !~ /\.save$/) {
      cancelService($urlist, $inputs{email});
   } else {
      $urlist="";
      $inputs{done_logout}="Logout";
      my $login=displayLogin();
      print "$login";
   }
   undef %inputs;
   exit;
}
#--- Check for user name, password match ----------------------------
if ($inputs{entry} eq "Submit") {
   #--- user is coming in from first access page
   if (! -e $infolist) {
      #if ($inputs{uname} =~ /[\&\:\<\>\,\'\\\/\s]/)  {
      if ($inputs{uname} =~ /[^\w\_\-\@\.]/)  {
            Browse::Utils::Error("<div class='errorbox'>The username " .
		" entered contains illegal characters " .
		#"(blank space, comma, \\, /, \&, \:, " .
		#"\<, \>, \') " .
		"and is not valid.<p> Please click  the browser " .
		"Back button and try again.</div>");
        }
      #--- new user so keep password around until next Submit
      $inputs{pkeye} = $keyw;
   } elsif ($keyw) {
      #--- Compare passwords
      my $dcipher = new Crypt::Blowfish $ckey;
      my $testword = retrieveWord($infolist);
      my $dtext = $dcipher->decrypt($testword);
      my $readtest = $dcipher->decrypt($keyw);
      if ($readtest eq $dtext) {
      } else { 
         #--- if user name and password do not match display 
         #--- error message and option to have password emailed
         #Browse::Utils::Error("<span style='background-color:#DDEEEE;width:95%;padding:5px;font-size:75%'>The password " .
         Browse::Utils::Error("<div class='errorbox'>The password " .
		 "and user name (" .$inputs{uname} . ") do not " .
		 "match.<p>  If you are a new user please " .
		 "pick another " .
		 "user name. <p>If you are a registered user please try " .
		 "again  or click the Send Password button and " .
		 "your password will be sent to the email currently on " .
		 "file.  <p><p>\n" .
                 "<form method='post' action='monitor_src.pl'>" .
		 "<INPUT TYPE='hidden' name='done_logout' value='Logout'>\n" .
		 "<INPUT TYPE='hidden' name='uname' value='" .
		 $inputs{uname} ."'>\n" .
		 "<INPUT TYPE='Submit' name='emailpword' " .
		 "VALUE='Send Password'>\n" ."&nbsp;&nbsp;&nbsp;&nbsp;" .
      		 "<INPUT TYPE='Submit' name='done_logout' " .  
		 "VALUE='Login Page'>\n" .  "</form></div><p>\n");
      }
   }
}
#--- login and password box
my $logindisplay = displayLogin($inputs{uname}, $urlist);   

my $formmessage="";
if ($inputs{uname} ne '') {
   my $user=$inputs{name};
   if (!-d $workdir) {
      #print "creating new account $user<br>" if $debug;
      #--- create user directory 
      $formmessage .= "<p><b>Welcome! Enter your email address, add a " .
	 "source, select missions and click the SUBMIT button</b><p>";
    
      mkdir ("$workdir", 0777) || 
	 Browse::Utils::Error("<div class='errorbox'>An error occurred" .
		" creating the user directory</div>");
      chmod (0777, "$workdir") || 
	 Browse::Utils::Error("<div class='errorbox'>An error occurred " . 
		"accessing the user's work directory</div>");
      system ("chmod g+w $workdir");
      system ("chmod g+s $workdir");

      my $ignorelist="$userdir/../files/ignore.list";
      copy($ignorelist, "$workdir/ignore.list") 
         or Browse::Utils::Error("<div class='errorbox'>The ignore list file" .
		"  cannot be copied</div>");	
   } else {
      #--- Instructions 
   }

       

   #--- if a submit button has been pressed get src table from form input 
   if ($form =~ /ckbutton/) { 
      # if $form contains ckbutton, then create source table 
      # from %input
      %srctable=get_src_table(%inputs);
   } 

   #
   #--- Handle email changes and email notification requests -----
   #

   #--- if  url list exists then get and display e-mail address and 
   #--- create watch list
   if (-e $urlist) {
      #--- read email from current url file
      $email = retrieveEmail($urlist);

      #--- Compare email from form submission with url list email and
      #--- set flag for notification if different
      if ($inputs{'email'}) { 
         my $newemail = $inputs{'email'} ;
         if ($newemail ne $email) {
            $inputs{notifyviaemail}=1;
            $email=$newemail;
         }
      }

      #--- if previous user returns read URLIST file for srctable
      #--- otherwise srctable already defined from above
      if ($form !~ /ckbutton/) { 
         %srctable=get_src_table_urlist($urlist);
      }
   } else {
      #--- Check that email address has been added
      if ($inputs{email}) {
         $email=$inputs{email};
         $inputs{notifyviaemail} = 1;
      } else {
         if ($inputs{done}) {
           Browse::Utils::Error("<div class='errorbox'>You must enter an" .
		" email address. Please hit the Back Button and try again.</div>");
         }
      }
   }
   #--- Display e-mail textbox (can be edited) 
   if ($email) {
      $formmessage .= "<br><p><b>Add/change sources or select for deletion" .
	 " and click one of the Submit buttons</b><p>";
      #$formmessage .= "<br><p><b>Delete Watch List entries or make other " .
	 #"additions/changes and click one of the Submit buttons</b><p>";
   }

   my $emaildisplay = "<p><br>\n" .
   	"<LABEL for='email'>Email:	</LABEL>\n" .
   	"<INPUT type='text' id='email'  size='40' name='email' " .
 	"value='$email' onkeypress='return disableEnterKey(event)'>"; 

   if (! $inputs{email} && ! -e $urlist) {  
      #if (! -e $urlist && $debug) {print "$urlist does not yet exist<br>";} 
      #--- name and password only submitted (first submit)
      $emaildisplay .= "<span style='font-size:75%'>\n" .
	   "Email is sent automatically " .
	   "after first Submit and if address is changed</span>\n<p><p><p>";
         #--- pass password param only if this is first Submit
      $emaildisplay .= "<input type='hidden' name='pkeye' value='$keyw'>\n"
   }

   #--- add new source if one has been entered
   $inputs{selectionOK}=1;
   if ($inputs{newsrcname} ne '') {
      my $newsrc=$inputs{newsrcname};
      #print "new source=$newsrc<br>" if $debug;
      $newsrc =~ s/\s*$//;
      $newsrc =~ s/^\s*//;

      #--- Resolve source and store sexagesimal format 
      #my $resolver;
      my $resolverlink="";
      my @resolved;
      @resolved =resolve_src($newsrc);
      #$newsrc=$resolved[0];
      my $newsrc_sx=$resolved[1];
      my $resolverlink=$resolved[2];
      #print "new source after resolve=$newsrc $newsrc_sx $resolverlink<br>" 
	#if $debug;
      $resolverlinks{"$newsrc"} = $resolverlink;

      #--- Check for duplicates already in watch list 
      my $newsrckey=":$newsrc_sx";
      $dupmsg="";
      $addmsg="";

      foreach my $key (keys %inputs) {
        #---  If src is already in table replace what is there
        my $dkey=Browse::CGI::Decode($key);
        (my $currentname = $dkey)=~s/ckbutton.*$//;  #src name
        if ($dkey =~ /$newsrckey$/) { 
           #print "---deleting $dkey $currentname ???<br>" if $debug;
           delete $inputs{$key};
           delete $srctable{$currentname};
           $dupmsg = "Mission selections for <b>$currentname</b> have " .
		"been updated";
        }
      }

      my $val="$newsrc_sx:";
		
      #--- attach missions to new source. Encode new source name to match
      #--- sources that will be read from file
      my $orgname = convertchar($newsrc);
      #print "orgname  $orgname<br>" if $debug; 
      my $tablechecked=0;
      if ($inputs{chandraadd} eq 'on') {
         $val=$val."+chandra";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonchanmaster:$newsrc_sx"}="on";
         $tablechecked=1;
      }
      if ($inputs{xmmadd} eq "on") {
         $val=$val."+xmm";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonxmmmaster:$newsrc_sx"}="on";
         $tablechecked=1;
      }
      if ($inputs{swiftadd} eq "on") {
         $val=$val."+swift";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonswiftmastr:$newsrc_sx"}="on";
         $tablechecked=1;
      }
      if ($inputs{suzakuadd} eq "on") {
         $val=$val."+suzaku";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonsuzamaster:$newsrc_sx"}="on";
         $tablechecked=1;
      }
      if ($inputs{rxteadd} eq "on") {
         $val=$val."+rxte";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonxtemaster:$newsrc_sx"}="on";
         $tablechecked=1;
      }
      if ($inputs{integraladd} eq "on") {
         $val=$val."+integral";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonintegralao:$newsrc_sx"}="on";
         $tablechecked=1;
      } 
      if ($inputs{spitzeradd} eq "on") {
         $val=$val."+spitz";
         $inputs{Browse::CGI::Encode($orgname) . 
		"ckbuttonspitzmastr:$newsrc_sx"}="on";
         $tablechecked=1;
      } 
      #print "adding $val to srctable for key $orgname<br>" if $debug;

      #--- Add new source to current source list
      if ($tablechecked) {
         $srctable{$newsrc}= $val;
      } else {
         $addmsg="Please enter a source and select at least one table.";
         #$inputs{selectionOK}=0;
      } 
   } elsif ($inputs{spitzeradd} eq "on" || $inputs{xmmadd} eq "on" || 
	    $inputs{integraladd} eq "on" || $inputs{rxteadd} eq "on" || 
	    $inputs{suzakuadd} eq "on" || $inputs{swiftadd} eq "on" || 
	    $inputs{chandraadd} eq "on" ) {
      $addmsg="Please enter a source and select at least one table."; 
      #$inputs{selectionOK}=0;
   } else {
      #-- If Submit but not delete has been hit
      if ($inputs{deletesrc} !~ /\w/ && $inputs{entry} != /\w/) {
         $dupmsg="Your Watch List has been updated."; 
      }
   }
   #--- Noe that we know there are no resolver errors display the user
   #--- iunformation section
   print $logindisplay;
   print "$formmessage\n";
   print "$emaildisplay\n";
		
#
#--- Display current watch table ------------------------------------
#
my $numsrcs=keys %srctable;
if ($numsrcs == 0) {
   print << "WATCHTABLEHEAD";
        <div style="background-color:#DDEEEE;width:95%;padding:5px;border: solid 1px #000">
        There are currently no sources in  your Watch List
        </div>
WATCHTABLEHEAD
} else {
   #--- watch table column names
   print << "WATCHTABLEHEAD";
        <div style="background-color:#DDEEEE;width:100%;padding:5px;border: solid 1px #000">
	<table width='100%'>
	<caption><b> Current Watch List </b></caption>
	<tr>
	    <td align="left">Delete</td>
	    <td>Source or Position</td>
	    <td align="center">Chandra</td>
	    <td align="center">XMM</td>
	    <td align="center">Swift</td>
	    <td align="center">Suzaku</td>
	    <td align="center">RXTE</td>
	    <td align="center">INTEGRAL</td>
	    <td align="center">Spitzer</td>
	</tr>
	<tr>
      <td colspan='9'><input type='checkbox' name='deleteall'  value='deleteall' onClick=tickTableByName(this.checked,'done_del')> All 
	</tr>
WATCHTABLEHEAD
       
   #--- display watch table column data
   foreach my $src (sort (keys %srctable)) {
     create_watchlist_entry($src,$user ,$srctable{$src}, $resolverlinks{$src} );
   }

   print "<tr><td colspan=8>&nbsp;</td></tr>";
   print "<tr><td colspan=3><span style='font-size:80%;'>Tables are checked for updates daily.<br>Click source to see resolver service page.</span></td><td align='right' colspan=5><span style='color:#F31;font-size:90%;'>  $dupmsg</span></td></tr>";
   print "</table></div><p><p>";
}
print "<p><p><p>";

#
#--- Add source and mission selection area to form ---------------------
#
displayNewSourceForm();

   
#--- If account has just been reactivated rest url list name now 
#--- that the watch list has been displayed
#print "react?  $reactivate.<br>" if $debug;
if ($reactivate ne '') {
   if (-e $reactivate  && -e "$reactivate.relogin") { 
      #print "removing $reactivate.relogin  because $reactivate exists<br>\n" 	
	#if $debug;
      system ("rm $reactivate.relogin");  #removed save list
   } else {
      #print "moving $urlist   to reactivate flag file $reactivate.rlogin <br>\n" 		if $debug;
      #--- moved save list to indicate re-login
      system ("mv $urlist $reactivate.relogin");  
      $urlist = $reactivate;  #rename url list 
   }
} 
print << "FREQ";
	
	<p><div ><span style='width:60%';><INPUT TYPE="Submit" name="done" VALUE="SUBMIT">
FREQ

   if ($inputs{done} || -e $urlist) {
      print "&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE='Submit' name='done_notify' " .
	   "VALUE='SUBMIT and email List'>";
   } else {
      print "</span>\n";
   }
   #print "&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE='Submit' name='done_logout' " .
	   #"VALUE='Logout'>";
   print "</span>";
   print "&nbsp;&nbsp;&nbsp;&nbsp;<span style='color:#F31;font-size:90%;'>" .
	   "  $addmsg</span>";

   print "</div><p><p>";

} else {  #--- user name exists
   print $logindisplay;
}


#
#----- Submit or DEL button pressed  so update url list file -----------------
#
if ($inputs{done} ne '') {
   
   %srctable=get_src_table(%inputs);
   #print "writing to $urlist<br>" if $debug;

   #--- Write to URLLIST file 
   open (URLIST, ">$urlist");
   print URLIST <<"URLLISTHEAD";
	Auth      = none
	Diff      = webdiff
	Hicolor   = blue
	Ignore    = General,Date_Time
	IgnoreURL = Adverts
	Tmin      = 0
	Tmax      = 99999
	Email     = $inputs{'email'}
	EmailLink = $inputs{'email'}
	MailFrom = HEASARC_DATA_NOTIFIER
	EmailError = 1
	AsciiMarker = 1
	Digest = true
	####
	####
	####
URLLISTHEAD
   my $urlistentry=mk_urllist_entry($inputs{'uname'},$urlist,%srctable);
   print URLIST "$urlistentry";
   close URLIST;

   #print "----$urlistentry----<br>" if $debug;
   if ($inputs{'notifyviaemail'}) { 
      #print "sending email message<br>" if $debug;
      my $list = retrieveURLList($urlist);  
      if ($list !~ /\w/) {
         $list="\tThere are no queries in your Watch List at this time.\n";
      }
      my $message="";
      if ($inputs{pkeye}) {
	$message .= "Queries in your Watch List after first submission:" ; 
      } else {
	$message .= "Current queries in your Watch List:";
      }
      $list="User: " . $inputs{uname} . "\n\n" . 
	"$message\n" .  $list. "\n"; 
      $list .= "\nLogin to the Browse Notification page\n" . 
        "http://" . $server . "/cgi-bin/W3Browse/" .
	"notification/monitor_src.pl\n" .
       " to view your current Watch List and to make changes.\n";

      if ($inputs{selectionOK}) {
         verifyEmail($email, $inputs{uname},$list);
         print "<div style='margin:0px 5px 0px 5px;height:8px;color:#F31;" .
	   "font-size:90%;' id='submit_message'>" .
           "A Browse Notification Service email is being sent to $email</b> " .
	   "</div><p>\n";
      }

   } 
   #if ($inputs{newsrcname} ne '') {
     #print "running runwebsec.pl $inputs{uname}<br>" if $debug;
     ##my $out = `cgi-bin/W3Browse/notification/runwebsec.pl $inputs{uname}`;
     #my $cmdout = `runwebsec.pl $inputs{uname}`;
     #print "out=$cmdout<br>" if $debug;
   #}
}
#--- Display list of changes
if ($inputs{uname} ne '') {
   displayDiffs();
}

#--- if new password or a reset password
if ($inputs{pkeye} && ! -e $infolist) {
   #print "writing infolist $infolist<br>" if $debug;
   open (INFO, ">$infolist") or 
	Browse::Utils::Error("<div class='errorbox'>User information " .
	"file could not be accessed</div>");
   print INFO $inputs{pkeye}. "\n";
   close (INFO);
   chmod 0600, $infolist;
}
close_page();

#----------------------------------------------------------------------------

sub close_page {
   print << "HTMLEND";
	</form>
   <p><br><span style='font-size:90%;'>If you have questions please visit our <a href="/cgi-bin/Feedback?selected=w3browse">Feedback form</a></span>
	</body>
	</html>
HTMLEND
}

#----------------------------------------------------------------------------
sub get_pos_tab($;$) {
   #
   # for a given $url that begins with 
   # http://heasarc.gsfc.nasa.gov/db-perl/W3Browse/w3query.pl
   # returns the position $pos and the table $tab being searched
   # usage: ($pos, $tab) = get_pos_tab($url)
   #
   use strict;	
   my $pos;
   my @tmp;
   my $tab;
   
   my @arg=@_;
   my $url=$arg[0];
   my @info=split(/&/,$url);
   foreach (@info) {
      if ($_=~ m/BATCHRETRIEVALCATALOG%5f2%2e0+/) {
         @tmp=split(/\+/);
         $tab=$tmp[1];
      }
      if ($_=~m/Entry=/) {
         @tmp=split(/=/);
         $pos=$tmp[1];
      }
   }
   return $pos, $tab;
}

#----------------------------------------------------------------------------
sub mk_urllist_entry() {
   #
   # given username, url file  and the %srctable hash, create the 
   # url.list entry: 
   # usage: $entry = mk_urllist_entry($uname, $file, %srctable);
   #
   my $uname=shift;
   my $urlist=shift;
   my %srctable=@_;
   #print "____________________________________<br>" if $debug;
   #print "mk_urllist_entry: $uname $urlist<br>" if $debug;

   my $urlistentry="\n";
   foreach my $source (keys %srctable){
      my $pos=$source;
      my $allvals=$srctable{$source};
      #print "mk_urllist SRC=$source all $allvals<br>" if $debug;

      #--- extract sexagesimal coords of source
      my ($sx_src, $val) = split(/\:/, $allvals, 2);
      #print "mk_urllist p1=$sx_src<br>" if $debug;
      #print "mk_urllist p2=$val<br>" if $debug;

      #--- get a list of tables to keep tabs on
      my @tab= split(/\+/, $val);
      my $tab=@tab;
      foreach my $table (@tab) {
         $table =~ s/\:.*$//;
         #print "mk_urllist_entry:  postion= $pos, table = $table <p>" if $debug;
         if ($table ne '') {
            #--- Create Browse URL
            my $url=mk_pos_url($pos,$table);
         #print "mk_urllist_entry:  url=" . Browse::CGI::Decode($url) . "<br>"  
		#if $debug;
            my $posn=$pos;
            my $name=$uname.$posn.$table;
	    $name =~ s/\s/_/g;
	    $name =~ s/'/%27/g;
            #$name = Browse::CGI::Encode($name);
            my $prefix=$name;
            $urlistentry= $urlistentry .
            "\n".
            #"# \n".
            #"# for $pos and $table \n".
            #"#\n".
            "# \n".
            "# Source: $pos		Mission: " . $missionNames{$table}."\n".
            "#\n".
            "URL       = ".$url		."\n" .
            "Name      = ".$name	."\n" .
            "Prefix    = " .$name 	."\n".
            "Hicolor   = lightgrey "	."\n";

            checkArchive($url,$name);
         }
      }
   }
   return $urlistentry;
}

#----------------------------------------------------------------------------
sub  create_watchlist_entry(){
   #
   # creates entry in watchlist HTML table given a $src, $user and $missions
   # create_watchlist_entry($src, $user, $missions);
   #
   my $src=shift;
   my $user=shift;
   my $missions=shift;
   my $rlink=shift;
 
   #--- pull out sexagesimal coords and tack them on the end of form parameter
   my ($sx_src,$rest) = split(/\:/, $missions);
  
   my $srcn=$src;
   my $srcid=$srcn;
   #my $srcid =~ s/'/\%27/g;   #apostrophe

   my $ckbox;
   #--- print source and allow deletion and mission checking and unchecking
   print "<tr>";
   ##print "<td><input type='Submit' name='done_del_$srcid' id=\"$user$key\" " .
	##"value=\"DEL\" ></td>\n";
  print "<td><input type='checkbox' name=\"done_del_$srcid\" " .
	"id=\"$user$key\" value=\"DEL\" ></td>\n";
   
   my $snameHtml = "<td id=\"$user$key\" name=\"$user$key\">";
   if ($rlink =~ /\w/) {
      $snameHtml .= "<a href='$rlink' target='r_page'>" .convertchar($srcn) . 
	"</a></td>\n";
   } else {
      $snameHtml .= "$srcn</td>\n";
   }
   print "$snameHtml";
   #print "<td id=\"$user$key\" name=\"$user$key\"><a href='$rlink'>$srcn</a></td>\n";
   if ($missions =~ m/chan/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonchanmaster:$sx_src\" id=\"chandra$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/xmm/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonxmmmaster:$sx_src\" id=\"xmm$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/swift/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonswiftmastr:$sx_src\" id=\"swift$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/suza/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonsuzamaster:$sx_src\" id=\"suzaku$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/xte/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonxtemaster:$sx_src\" id=\"xte$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/int/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonintegralao:$sx_src\" id=\"integral$srcid\" $ckbox ></td>\n";
   if ($missions =~ m/spitz/) {$ckbox='CHECKED';} else {$ckbox='';}
   print "<td align=\"center\"><input type=\"checkbox\" name=\"".$srcid .
	"ckbuttonspitzmastr:$sx_src\" id=\"spitz$srcid\" $ckbox ></td>\n";
   print"</tr> \n" ;
}


#----------------------------------------------------------------------------
sub mk_pos_url() {
   #
   # for a given position $pos (can be a source name or ra & dec) and a 
   # browse table (like chanmaster), create url which points to the 
   # browse results for that position for that table
   # usage: $url = mk_pos_url($pos, $tab)
   #
   use strict;    
   my @arg=@_;
   my $pos=$arg[0];
   my $table=$arg[1];
 
   #print "mk_pos_url $pos<br>" if $debug;
   $pos=Browse::CGI::Encode(convertchar($pos));
   #print "mk_pos_url $pos after encode <br>" if $debug;

   my $url="http://heasarc.gsfc.nasa.gov/db-perl/W3Browse/w3query.pl?" .
	"tablehead=name%3dBATCHRETRIEVALCATALOG%5f2%2e0+";
   $url=$url.$table."&Action=Query&Coordinates=Equatorial%3a+R%2eA%2e+Dec&";
   #$url=$url."Equinox=2000&Radius=60&NR=CheckCaches%2fSIMBAD%2fNED&GIFsize=0" .
   $url=$url."Equinox=2000&Radius=60&NR=CheckCaches%2fSIMBAD&GIFsize=0" .
	"&Fields=Standard&";
   $url=$url."Entry=$pos"."&ResultMax=0&displaymode=TextDisplay";
   return $url;
}


#----------------------------------------------------------------------------
sub get_src_table(){
   #
   # get source table from input hash
   # usage: %srctable = get_src_table(%inputs);
   #
   my (%inputs)=@_;

   my $pos;
   my $val;

   %srctable=(); # clear source table
   #my $sx_src;
   my $m;
   my %sx_pos;
   foreach $key (sort (keys %inputs)) {
      #$sx_src = "";
      #print "**** get_src_table: key= ".$key." ******<br>" if $debug;

      #--- parse strings with src and mission list
      if ($key =~ /ckbutton/){
        $key=Browse::CGI::Decode($key);

	($pos,$val)=split('ckbutton',$key);

	#print " get_src_table: adding ckbutton POS= ".$pos.
		#" Value=  ".$val."<p>" if $debug;

        #--- resolver src to get reolverlink
           #print "hash $pos --> " . $sx_pos{"$pos"} . "<p>" if $debug;
        if ($sx_pos{"$pos"} !~ /\w/) {
           my $rlink="";
           #print "RESOLVING $pos<p>" if $debug;
           my @results=resolve_src($pos);
           if ($results[2] =~/\w/) {$rlink=$results[2];}
           $resolverlinks{$pos}=$rlink;   #global hash var
           #print "Adding $pos to hash " . $sx_pos{"$pos"} ."<br>" if $debug;
           $sx_pos{"$pos"} = $results[1];
        }
        #--- get sexagesimal coords resolve results and
        #--- attach to front of value
        #if ($sx_src !~ /\w/) {
        if ($sx_pos{"$pos"} =~ /\w/) {
        #if ($results[1] =~ /\w/) {
           #($m,$sx_src) = split(/\:/,$val);
           #print "getting sx_src $sx_src vs $results[1]<br>";
	   #$srctable{$pos}=$srctable{$pos}.$sx_src.":"; 
	   #$srctable{$pos}=$srctable{$pos}.$results[1].":"; 
	   $srctable{"$pos"}=$srctable{"$pos"}.$sx_pos{"$pos"}.":"; 
        }
        #print " get_src_table: chkbutton POS= ".$pos." Value=  ".$val."<p>" if $debug;

        #--- accumulate missions to be checked
        $srctable{$pos}=$srctable{$pos}."+".$val; 
        #print "This is it: srctable value =" . $srctable{$pos} . "<br>" if $debug;
     }
   }	
   #print " get_src_table: <p>";
   #foreach $key (keys %srctable) {
      #print $key, "-->".$srctable{$key}."<p>" if $debug;
   #}
   return %srctable;
}

#----------------------------------------------------------------------------
sub get_src_table_urlist(){
   #
   # gets %srctable hash from $urlist file (url.list)
   # used when previous user accesses page
   # usage: %srctable=get_src_table_urlist($urlist)
   #
   my $pos;
   my $resolver;
   my $tab;
   
   my $urlist=shift;
   open (URLS, "<$urlist") or 
	Browse::Utils::Error("<div class='errorbox'>List of Browse URLs" .
		" could not be accessed</div>"); 	
   my @url=<URLS>;
   my $pos_sx;
   my $resolverlink="";
   foreach my $urltest (@url) {
      if ($urltest =~ m/w3query.pl/ ) {
         ($pos,$tab)=get_pos_tab($urltest);
         $pos = Browse::CGI::Decode($pos);
         #--- resolve src to get its sexagesimal coords
         my @resresults; 
         #$pos, $pos_sx, $resolverlink = resolve_src($pos);  
         @resresults = resolve_src($pos);  
         $pos=$resresults[0];
         $pos_sx=$resresults[1];
         $resolverlink=$resresults[2];
         $resolverlinks{"$pos"} = $resolverlink;
  	 $value='';
         #--- attach sexagesimal coords at front of mission list
         if (exists $srctable{$pos}) {
            $value=$srctable{$pos};
         } else {
            $value="$pos_sx:";
         }
         $srctable{"$pos"}=$value.'+'.$tab;
         #print "get_src_table_urlist:Source=$pos and table=$tab " . 
	 	#$srctable{$pos} . "<p>" if $debug;
      }
   }
   return %srctable;
}

#----------------------------------------------------------------------------
sub resolve_src {
   my ($src) = @_;
   $src = convertchar($src);
   #my @res = ("GRB","SIMBAD","NED");
   my @res = ("GRB","SIMBAD");
   my @resolvers;
   my $use_cache=1;
   my $coord_sys=Astro::CoordSys->new('system' => "Equatorial",
                                          'equinox' => "2000" );
   my $msg="";
   foreach my $res (@res) {
      @Astro::Object::Resolver::CheckCaches::default_caches_to_check=($res);
      my $resolver = Astro::Object::Resolver->new('type' => $res,
                                              'use_cache' => $use_cache);
      push(@resolvers,$resolver) if $resolver;
   }
   my @objects;
   my $format="sexagesimal";
   my $listformat = "";
   

   #-- used if resolvers return fatal error
   $Astro::Config::error_handler=\&{sub {}};   

   foreach my $resolver (@resolvers) {
      my $obj = Astro::Object->new('string'=>$src,
                                   'coordsys'=>$coord_sys,
                                   'resolver'=>$resolver);
      push(@objects,$obj) unless $obj->error();
      #--- Add warning for GRB resolver only if entry is GRB
      if ($obj->error() && 
         ($resolver->{name} =~ /GRB/ && $src =~ /^GRB/)) {
         $msg .= "<br>" if $msg;
         if ($resolver == $resolvers[0]) { 
            $msg .= "WARNING!"; 
         } else {
            $msg .= "Comment:";
         }
         $msg .= " <i>$src</i> is not known to the ".
		  $resolver->name()." resolver.";
      } 
   }
   my $error;
   #print "checking source " .scalar(@objects) ."<br>\n" if $debug;
   unless (scalar(@objects)) {
      Browse::Utils::Error("<div class='errorbox'><i>$src</i> is not " .
		"recognized by the ".
		join(" or ",@res)." name resolver".($#res>=1?"s":"").".<br>" .
                "If you are trying to enter a coordinate string " .
		"give at least minutes for sexagesimal coordinates or " .
		"use a decimal point in decimal coordinates.  Also separate " .
		"the longitude/RA and latitude/Dec by a comma or the sign " .
		"of the latitude/declination.  <br>E.g., use " .
    		"12.,14. or 12 00 +14 00 rather than 12,14<br>" .
		"Please hit the Back Button and try again</div>");
   }
   my $object = $objects[0];
   my $coords=$object->coordinates(format=>$format);
   my $resolver=$object->resolver_used() ;
      
   my ($sra,$sdec) = @{$coords};
   $sdec =~ s/\+//;

   my $resolverlink;
   if ($resolver =~ /SIMBAD/i) {
      $resolverlink = "http://simbad.u-strasbg.fr/simbad/sim-id?" .
	"protocol=html&Ident=" .Browse::CGI::Encode($src);
   } elsif ($resolver =~ /NED/i) {
      $resolverlink = "http://nedwww.ipac.caltech.edu/cgi-bin/nph-objsearch?" .
	"objname=" .Browse::CGI::Encode($src) ."&extend=no";
   } elsif ($resolver =~ /GRB/i) {
      $resolverlink="http://heasarc/cgi-bin/Tools/convcoord/convcoord.pl?" .
	"CoordVal=". Browse::CGI::Encode($src) . "&Resolver=GRB%2FSIMBAD%2FNED";
   }

   #--- save in sexagesimal format too for source comparisons
   my $res_newsrc_sx="$sra,$sdec";  
   #print " resolver: $res_newsrc_sx $resolverlink<br>" if $debug;
   #$src =~ s/\+//;
   return ($src, $res_newsrc_sx, $resolverlink);
}
#----------------------------------------------------------------------------
sub verifyEmail {
   my ($email, $username, $body) = @_;

   #my $from = "lmm\@milkyway.gsfc.nasa.gov";
   my $from = "HEASARC_DATA_NOTIFIER";
   my $domain;
   if ($email =~ /^[^\@]+\@([^\@]+)$/) {
      $domain = $1;
   } else {
      Browse::Utils::Error("<div class='errorbox'>Email address $email " .
	"could not be parsed</div>");
   }

   my $mailprog = '/usr/lib/sendmail -oi';
   my $subject = "Browse Notification Service"; 

   if ($email =~ /(\w{1}[\w-.]*)\@([\w-.]+)/) {
      $email = "$1\@$2";  # to untaint $email
   } else {
       Browse::Utils::Error("<div class='errorbox'>$email: " .
		"Invalid Address Format</div>");
   }
   if (! is_tainted($email) ) {
      # Use these values to send the mail to $recipient
      open (MAIL, "|$mailprog $email") ||
	   Browse::Utils::Error("<div class='errorbox'>An error occurred " .
		"while sending mail.</div>");
   
print MAIL	<<"MailTo";
From: $from
To: $email
Subject: $subject

$body

MailTo

close (MAIL);
}  else {
   Browse::Utils::Error("<div class='errorbox'>Email could not be " .
       "sent to $email</div>");
}
#print "message $body from $from sent to $email subject $subject<br>";
}

#----------------------------------------------------------------------------
sub emailPword {
   my ($username, $crkey)=@_;
   my $userdir='/tmp.shared/websec/bnotification/users';
   my $workdir ="$userdir/".$username;
   my $infolist ="$userdir/".$username."/info.list";
   my $urlist ="$userdir/".$username."/url.list";
   my $email = retrieveEmail($urlist);
   my $word = retrieveWord($infolist);
   my $cipher = new Crypt::Blowfish $crkey;
   my $dtext = $cipher->decrypt($word);
   #print "mailing password " . $username . " $urlist $email<br>" if $debug;
   
   my $message = "Your Browse Notification password is:\n $dtext.\n\n" .
      "If you have any questions regarding your account, please contact us at".
	" http://heasarc.gsfc.nasa.gov/cgi-bin/Feedback?selected=w3browse\n";
    $message .= "\nSincerely,\n\nThe Browse Notification Service\n";
   verifyEmail($email,$username,$message);
}

#----------------------------------------------------------------------------
sub retrieveWord {
    my ($wfile) = @_;
    open (INFOIN, "<$wfile") or 
	Browse::Utils::Error("<div class='errorbox'>An error occurred " .
		"validating password.</div>");
    my @testword=<INFOIN>;
    close (INFOIN);
    my $testword=$testword[0];
    #print "tesword $testword<br>" if $debug;
    chop $testword;
    return $testword;
}
#----------------------------------------------------------------------------
sub retrieveEmail {
   my ($urlist) = @_;
   if (! -e $urlist) {
      Browse::Utils::Error("<div class='errorbox'>There is no account" .
	" associated with this user name.</div>");
      return;
    }

   open (URLS, "<$urlist") or 
	Browse::Utils::Error("<div class='errorbox'>List of Browse URLs" .
		" could not be accessed.</div>"); 	
   my $data="";
   while (<URLS>) {
      if (m/EmailLink/) {
         my @temp=split(/=/,$_);
	 $email=$temp[1];
	 $email=~s/\s//g;
      }
   } 
   return $email;
}

#----------------------------------------------------------------------------
sub retrieveURLList {
   my ($urlist)=@_;
   open (URLS, "<$urlist") or 
	Browse::Utils::Error("<div class='errorbox'>List of Browse URLs" .
		" could not be accessed.</div>"); 	
   my $data="";
   while (<URLS>) {
      if (/^#/ || /w3query/) {
         $data .= "$_";
      }
   }
   return $data;
}

#----------------------------------------------------------------------------
sub is_tainted {
   not eval {
     join("",@_), kill 0;
     1;
   }
}
#----------------------------------------------------------------------------
sub displayLogin {
   my ($uname, $ulist) = @_;
   #print "in displayLogin!<br>" if $debug;
   my $divcolor;
   if ($uname ne '') {
      $divcolor = "#DDD"
   } else {
      $divcolor = "#222"
   } 
   my $html = "";
   $html .= "<h2 align='center'>The HEASARC Browse Notification Service</h2>\n";
   $html .= "<span style='font-size:90%'>" . 
   "This service allows users to be notified when changes " .
   "(e.g. an observation is scheduled, completed, or archived) " .
   "occur for a source in selected mission master tables. <p>" .
   "</span><p>\n";

   #$html .= "<div style='font-size:90%;border: solid 1px #000;padding:5px'>" . 
   #"<b>July 21, 2008</b>: Please note there are now Select All checkboxes " .
   #"that can be used when deleting sources from the Watch List and from the " .
   #"list of table changes.   Please " .
   #"<a href='/cgi-bin/Feedback?selected=w3browse'>contact us</a> " .
   #"if you have questions. ".
   #"</div><p> ";

   #$html .= "<div style='font-size:90%;border: solid 1px #000;padding:5px'>" . 
   #"<b>June 18, 2008</b>: The SIMBAD service is now used exclusively" .
   #" to resolve source names.  This will prevent unnecessary notifications " .
   #" that are based on a resolver change rather than a change to a " .
   #"mission table. A slight change had to be made to a few source names" .
   #" in the Watch Lists.  Please " .
   #"<a href='/cgi-bin/Feedback?selected=w3browse'>contact us</a> " .
   #"if you have questions. ".
   #"</div><p>\n";


   #--- Display instructions for first page access
   if ($uname eq '') { 
      #-- Instructions for logging in (first access login page)
      $html .= "\n<b>To start, enter a user name, password and click Submit.</b>";
      $html .= "<p><span style='font-size:80%'>New users: Please create a " .
	"password with 8 characters.  For user name and password " .
	"please use only alpahnumeric and the following characters " .
	"<b>_ - @ . </b> (underscore, dash, at sign, period)" .
	#"do NOT use  a blank space or the following illegal " .
	#"characters<b> \\ / & : < > , '</b><br> (slashes, ampersand, colon, " .
	#"less than, greater than, comma and apostrophe) 
        " </span><p>\n";
   } 
   
   $html .= "<P><p>\n";
   
   #--- Display user name entry box
   $html .= "<form method='post' action='monitor_src.pl'>\n";
   $html .= "<div style='background-color:#DDE;border:1px solid " .
	"$divcolor; width:95%;padding:10px 10px 10px 5px;'>\n";
   $html .= "<span ><LABEL for='uname'>Name: </LABEL>\n";
   $html .= "<INPUT type='text' id='uname' size='30' name='uname' ";
   
   #--- Display user name in entry box if not first page access
   if ($uname ne '') {
      $html .= "value='$uname' readonly " .
	"onkeypress='return disableEnterKey(event)' ";
   } else {
      #-- first access login page
      $html .= "value='' ";
   }
   $html .= ">\n";
   #--- Display password box on first access page ------------------------
   if ($uname eq '') { 
      $html .= "<p><LABEL for='pword'>Password:	</LABEL>\n";
      $html .= "<input type='password' name='password' id='pword'><p>\n";
      $html .= "<input type='Submit' name='entry' value='Submit'>\n";
      $html .= "<input type='Reset' name='Reset' value='Reset'>\n";
      $html .= "<span style='font-size:90%;padding-left:10px'>" . 
	"<a href='monitor_src.pl?needpassword=1'>Forgot Your Password?</a> " .
	"</span>\n";
      $html .= "<span style='font-size:90%;padding-left:10px'>" . 
       "<a target='helpwin' href='/W3Browse/bnotification-help.html'>Help</a>" .
	"</span>\n";
   } 

   $html .= "</span>\n";
    
   if ($inputs{uname} && !$inputs{done_logout}) {
      $html .= "<span style='margin:0px 5px 0px 40px;'>" .
	"<INPUT TYPE='Submit' name='done_logout' " .  "VALUE='Logout'></span>";
   }
   if (-e $ulist && $ulist !~ /save/) {
      if (retrieveEmail($ulist)) {
         $html .= "<span style='margin:0px 5px 0px 95px;' >" .
	   "<INPUT TYPE='Submit' name='done_cancel' " .
	   "VALUE='Cancel Notification Service'></span>\n";
      }  
      
   } elsif ($urlist =~ /\.save$/ && $reactivate_message =~ /\w/) { 
      $html .= "<span style='margin:0px 5px 0px 55px;color:#F31;" .
	   "font-size:85%;' >" .
	   "$reactivate_message" .
	   "</span>\n";
   }
   $html .= "</div>\n";

}

#----------------------------------------------------------------------------
#--- Display recent files that detail table changes
sub displayDiffs {
   #$archivedir=$workdir.'/archive';
   if (! -e $archivedir) {return;}
   opendir(ARCHIVE, $archivedir) or	
	Browse::Utils::Error( "<div class='errorbox'>The Archive directory " .
	"could not be accessed.</div>"); 	
   print "<hr><b>View details of recent Browse table changes" .
	"</b><p>\n";
   #print "<span style='font-size:80%'>Files are deleted 10 days after data changes are detected</span><p>\n";
   my @files = grep /.*:.*:.*d/, readdir ARCHIVE;
   if (scalar(@files) == 0) {
      print "No table changes have been detected<p>\n";
      return;
   }

   my %newhash;
   foreach my $f (@files) {
      my @stats = stat("$archivedir/$f");
      $newhash{$f} = $stats[9];
      #print "$f " .$newhash{$f}. "--<br>";
   }
   my @sorted = sort {
         $newhash{$b} cmp $newhash{$a}
   } keys %newhash;    # and by value

   for my $x (@sorted) {
      $x=~ /$inputs{uname}(.*)(\d{4}-\d{2}-\d{2})_(.*)d/;
   }
   
   
   my $tablehtml="<table width='100%' border=0>\n";
      $tablehtml .=  "<tr style='background-color:#DDE'><td colspan='9'><span style='margin-right:40px'><input type='checkbox' name='selectall'".
	#" value=\"selectall\" onClick=tickTable(this.form.dfiles,this.checked,'')> Select all for deletion</span>\n";
	" value=\"selectall\" onClick=tickTableByName(this.checked,'done_file')> Select all for deletion</span>\n";
      $tablehtml .= "Click Submit to delete selected items\n";
      #$tablehtml .= "<input type='Submit' " . 
	#" value=\"Delete checked items\" ></td></tr>\n";
      $tablehtml .= "<tr><td></td></tr> ";  
      
   #my $diff_found=0;

   foreach my $ff (@sorted) {
      $ff=~ /$inputs{uname}(.*)(\d{4}-\d{2}-\d{2})_(.*)d/;

      #-- Separate object, table name and date
      my $filebase=Browse::CGI::Encode($1).$2."_".$3;
      my $obj_table=$1;
      #print "$obj_table<br> " if $debug;
      my $date_time="$2 $3";
      $obj_table =~ /(.*)(spitzmastr|xtemaster|chanmaster|integralao|xmmmaster|suzamaster|swiftmastr)/;
      my $obj=convertchar($1);
      my $table=$2;
      
      my $diffdesc="$obj " . $missionNames{$table} . " $date_time"; 
     
      my $current =$inputs{uname} . $filebase ."new.html";
      my $orgfile =$inputs{uname} . $filebase ."org.html";
       $ff =$inputs{uname} . $filebase ."d.html";
       #print "--- $current<br>$orgfile<br>$ff<br> " . Browse::CGI::Decode($orgfile) . "<br>" if $debug;
      if (! -e "$archivedir/" . Browse::CGI::Decode($orgfile)) {
         next;
      }

      #--- Create table of current and past changes
      $tablehtml .= "<tr>";
      $tablehtml .= "<td><input type='checkbox' name='done_file_".
	Browse::CGI::Decode($ff) ."' value=\"DEL\" id='dfiles'></td>\n";
      ##--$tablehtml .= "<td><input type='Submit' name='done_file_".
	##--Browse::CGI::Decode($ff) ."' value=\"DEL\" ></td>\n";
      $tablehtml .= "<td>$diffdesc &nbsp;&nbsp;</td>\n" .
	"<td><a href='$archivedir/$ff'>Changes</a></td>";
      $tablehtml .= "<td>&nbsp;|&nbsp;</td>\n" .
	"<td><a href='$archivedir/$orgfile'>Previous results</a></td>\n";

      $tablehtml.= "<td>&nbsp;|&nbsp;</td>\n"; 
      if (-e "$archivedir/" . Browse::CGI::Decode($current))  {
	$tablehtml .= 
	     "<td><a href='$archivedir/$current'>New results</a></td>\n";
      } else {
	$tablehtml .= "<td>No New Results file</td>\n";
      }
      open (IN, "$archivedir/" .Browse::CGI::Decode($ff)) or next;
      while (<IN>) {
         my $line=$_;
         if ($line =~ /<BASE/) {
            $line =~ /(http:.*)">/;
            $tablehtml .= "<td>&nbsp;|&nbsp;</td>\n" .
		"<td><a href='$1'>Re-run query</a></td>";
            last;
         }
      }
      close(IN);
      $tablehtml .= "</tr>\n";
   }
   $tablehtml .= "</table>\n";
   print $tablehtml; 
}
#----------------------------------------------------------------------------
sub cancelService {
    my ($ulist, $email) = @_;
   #print "ulist = $ulist<br>" if $debug;
   if (-e $ulist) {
      my $msg="Your Browse Notification service has " .
	"been cancelled as requested.  Log back in at a later time to " .
	"reactivate your acoount.\n\n" .
	"User id:  " .  $inputs{uname} . "\n\n" .
        "http://" . $server . "/cgi-bin/W3Browse/" .
	"notification/monitor_src.pl\n" ;
      $msg .= "\nSincerely,\n\nThe Browse Notification Service\n";
      verifyEmail($email, $inputs{uname},$msg);
      system ("mv $ulist $ulist.save");
      #print "mving ulist $ulist.save <br>" if $debug;
      print "<p><div class='errorbox'><p><h2>Your notification service has been " .
	"cancelled as requested.  Log back in at a later time to " .
	"reactivate your account.</h2><p>";
      print "<form method='post' action='monitor_src.pl'>";
      print "&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE='Submit' name='done_logout' " .
	"VALUE='Logout'>";
      print "</form></div>";
   } else {
      #print "no ulist $ulist <br>" if $debug;
   }
}

sub displayNewSourceForm {
  print << "ADJUSTSRC";
   <hr width='90%'><span style='font-size:90%'><p><b>Add New Entries to Watch List</b></span><p>
   <LABEL for="newsrcname">Source name/J2000 position:	</LABEL>
   <input type="text" name="newsrcname" size="30" Value="" id="newsrcname"  onkeypress='return disableEnterKey(event)'> </P>
   <p><table cellpadding=0 cellspacing=0><tr><td>Select missions:</td>
</tr><tr><td>
   <table cellpadding=0 cellspacing=7><tr><td><input type=\"checkbox\" name="chandraadd" id="chandraadd" >
	   <a href="/W3Browse/chandra/chanmaster.html">Chandra</a></td>
        <td><input type=\"checkbox\" name="xmmadd" id="xmmadd" >
	   <a href="/W3Browse/xmm-newton/xmmmaster.html">XMM</a></td>
        <td><input type=\"checkbox\" name="swiftadd" id="swiftadd" >
	   <a href="/W3Browse/swift/swiftmastr.html">Swift</a></td>
        <td><input type=\"checkbox\" name="suzakuadd" id="suzakuadd" >
	  <a href="/W3Browse/suzaku/suzamaster.html">Suzaku</a></td>
        <td><input type=\"checkbox\" name="rxteadd" id="rxteadd" >
	  <a href="/W3Browse/xte/xtemaster.html">RXTE</a></td>
        <td><input type=\"checkbox\" name="integraladd" id="integraladd" >
	  <a href="/W3Browse/integral/integralao.html">INTEGRAL</a></td>
        <td><input type=\"checkbox\" name="spitzeradd" id="spitzeradd" >
	  <a href="/W3Browse/spitzer/spitzmastr.html">Spitzer</a></td>
        <td><input type=\"button\" name="sel_allmissions" id="sel_allmissions" value="Select All Missions" onClick='return selectAllMissions(this,"add")';>
        </tr></table></td></tr></table>
ADJUSTSRC
}

#--- Creates file with Browse results for future comparisons
#--- Email is sent to programmer (not user) if an error occurs
#--- Inputs:  Browse URL and user id
sub checkArchive {
   my ($url, $name) = @_;
   my $erroremail='Laura.M.McDonald@nasa.gov';
   my $errormessage="";
   my $contenterror=0;

   if (! -e $archivedir) {
      mkdir $workdir,    0777 if !-d $workdir;
      mkdir $archivedir, 0777 if !-d $archivedir;
      system("chmod 777 $archivedir");
   }

   my $outputfile="$archivedir/$name.html";
   if (-s $outputfile) {return;}

   #print "---No previous version of $outputfile. " .
	#"Storing results from $url in archive...<br>\n" if $debug;

   # Download URL using LWP
   my $ua = new LWP::UserAgent;
   my $req = new HTTP::Request( 'GET', $url );
   my $resp = $ua->request($req);
   if ($resp->is_success ) {

      my $mycontent=$resp->content;

      #--- look for error messages in output

      if ($mycontent =~ /Table (.*) does not seem to exist!/) {
         $errormessage .= "Output indicates $1 does not exist\n";
         $contenterror=1;
      } 
      if ($mycontent =~ /our system is overloaded/) {
         $errormessage .= "Output indicates that the query was not able " .
                "to be processed at this time\n";
         $contenterror=1;
              
      } 
      if ($mycontent =~ /Error: No table info found for/i) {
         $errormessage .= "A database error has occurred:\n";
         $errormessage .= "No table info found for \n$url";
         $contenterror=1;
      }
      if ($mycontent !~ /Text Display of Query Results/i) {
         $errormessage .= "An error has occurred with the Text " .
		"Display of results\n";
         $contenterror=1;
      }
      if ($mycontent =~ /is not recognized/i) {
         $errormessage .= "\nThis may be a resolver issue\n";
         $contenterror=1;
      }

      #--- send email if there was an error
      if ( $contenterror) {
         verifyEmail($erroremail, $inputs{uname},$errormessage . "\n" . $url);
      } else {
         open( HTML_FILE, ">$outputfile" );
         print HTML_FILE "<!-- X-URL: ", $resp->base, " -->\n";
         print HTML_FILE "<BASE HREF= \"", $resp->base, "\">\n";
         my ($type, $charset) = $resp->content_type;
         if ($charset) {
             print HTML_FILE "<meta http-equiv=\"Content-Type\" content=\"", 
                $type, "; ", $charset ,"\"/>\n";
         }
         print HTML_FILE $resp->content;
         close HTML_FILE;

         system("chmod 666 $outputfile");
         #system("chmod g+w $outputfile");
         #system("chmod g+r $outputfile");
   
      }
   } else {
      #print "<h3> An error has occurred</h3>" if $debug;
      $errormessage = "URL error: $url";
      verifyEmail($erroremail, $inputs{uname},$errormessage);
   }
}

#--- Not used right now -- this is what the websec script uses.
#sub MailMessage() {
    #my $message    = shift (@_);
    #my $subject    = shift (@_);
    #my @recipients = split /,/, shift (@_);
    #my $from       = shift (@_);
#
    #foreach $email (@recipients) {
        #$req = HTTP::Request->new( POST => "mailto:" . $email );
        #if ( $from ne "" ) {
            #$req->header( "From",   $from );
            #$req->header( "Sender", $from );
        #}
        #$req->header( "Subject",      $subject );
        #$req->header( "Content-type", "text/plain; charset=us-ascii" );
        #$req->header( "Content-Transfer-Encoding", "7bit" );
        #$req->header( "MIME-Version",              "1.0" );
        #$req->content($message);
#
        #$ua = new LWP::UserAgent;
        #$ua->request($req);
    #}
#}

sub convertchar {
    my ($word) = @_;
    $word =~ s/%27/'/g;
    return $word;
}
