#include <stdio.h>
#include <string.h>
#include <simcli.h>

#define EXIT_STATUS_ERROR	1
#define EXIT_STATUS_SUCCESS	0

int main(int argc,char **argv)
{
    char service[8], userid[MAX_USERID+1], passwd[MAX_USERID+1];
    char rec[256];
    int handle, nitems, ndata;
    char *object_name, *error_message;
    int status = EXIT_STATUS_ERROR;

    /* If there are three arguments ignore the first two...*/
    if (argc == 4) {
	argv[1] = argv[3];
	argc = 2;
    }
    
    if (argc == 2)
      {
	  *service = '\0';
	  object_name = argv[1];
	  if ((handle = simbad_connect("",service,"u616idsv","yjqjmzex")) != -1)
	    {
	        if ((nitems = simbad_query(handle,object_name,"")) >= 1)
		  {
		      /* retrieve 1st object */
		      simbad_retrieve(handle,1);
		      if ((ndata = simbad_findata(handle,"J","")) == 1)
			{
			    puts(simbad_getdata(handle,1));
			    
			    status = EXIT_STATUS_SUCCESS;
			}
		  }
		else if (nitems == -1)
		  printf("SIMBAD Error: %s",simbad_error(handle));
		else if (nitems == 0)
		  printf("Error: Object name not recognized by SIMBAD name resolver.\n");
		simbad_disconnect(handle);
	    }
	  else
	    printf("Error: Could not connect to SIMBAD.\n");
      }
    else
      printf("Error: Number of arguments is incorrect.\nUsage: %s objectname\n",argv[0]);

    exit(status);
}
